/**
 * This file is part of GenomeView, a genome browser and annotation curator
 * 
 * Copyright (C) 2007-2017 Thomas Abeel and contributors
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 * Project: http://genomeview.org/
 */
package net.sf.jannot.tabix.codec;

import net.sf.jannot.pileup.DoublePile;
import net.sf.jannot.pileup.ReadDetailPile;
import net.sf.jannot.tabix.TabixLine;

/**
 * @author Thomas Abeel
 * 
 */
public class PileupCodec extends Codec<DoublePile> {
	

	/**
	 * @param in
	 */
	public PileupCodec(Iterable<TabixLine> in) {
		super(in,15000);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see net.sf.jannot.tabix.codec.Codec#parse(java.lang.String)
	 */
	@Override
	public DoublePile parse(TabixLine line) {
		DoublePile f = lru.get(line);
		if (f != null)
			return f;
		else {
			int pos = line.getInt(1);
//			int coverage = line.getInt(3);
			byte[] reads = line.get(4).getBytes();
			ReadDetailPile p = ReadDetailPile.create(pos, reads);
			lru.put(line, f);
			return p;
		}
	}

}
